'''
Created on 2009/05/23
'''

import sympy
import motion_equation

def main():
    
    # Sample for Newton's second law
    
    mat = sympy.Matrix
    t, x, m, f = sympy.symbols(
        "t, x, m, f")
    
    pos_vec = mat([x(t),0,0])
    force_vec = mat([f(t),0,0])
    I_mat = sympy.zeros(3)
    ome_vec = sympy.zeros([3,1])
    torque_vec = sympy.zeros([3,1])
    
    result = motionequation.get_withKane(
        t, [x(t).diff(t)], [m],
        [pos_vec],
        [I_mat],
        [ome_vec], 
        [pos_vec], [force_vec], 
        [ome_vec], [torque_vec])
    
    print "Newton's second law: "
    sympy.pprint(result)
    print "https://secure.wikimedia.org/wikipedia/en/wiki/Newton%27s_laws_of_motion#Newton.27s_second_law"
    
    # Euler's equations (rigid body dynamics)
    
    mat = sympy.Matrix
    t, m, I_1, I_2, I_3 = sympy.symbols(
        "t, m, I_1, I_2, I_3")
    x, y, z, ome_1, ome_2, ome_3, tau = sympy.symbols(
        "x, y, z, ome_1, ome_2, ome_3, tau")
    
    pos_vec = mat([x(t),y(t),z(t)])
    force_vec = mat([0,0,0])
    I_mat = mat([[I_1,0,0],[0,I_2,0],[0,0,I_3]])
    ome_vec = mat([ome_1(t),ome_2(t),ome_3(t)])
    torque_vec = mat([0,0,tau(t)])
    
    result = motionequation.get_withKane(
        t, [ome_1(t),ome_2(t),ome_3(t)], [m],
        [pos_vec],
        [I_mat],
        [ome_vec], 
        [pos_vec], [force_vec], 
        [ome_vec], [torque_vec])

    print "Euler's equations (rigid body dynamics): "
    sympy.pprint(result)
    print "https://secure.wikimedia.org/wikipedia/en/wiki/Euler%27s_equations_(rigid_body_dynamics)"

main()